<?php
# Copyright(C) 2004-2008 INL http://www.inl.fr/
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#            Jean Gillaux <jean@inl.fr>
#            Damien Boucard <damien.boucard AT inl.fr>
#
# $Id: acls.php 17927 2009-02-16 13:16:09Z haypo $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

$title='acls';
$singtitle='acl';
$header_ask_list_change=Array('sortcat');
require_once ("include/common.php");
require_once ("include/headers.php");
require_once ("include/display.php");
require_once ("include/acl_func.php");
require_once ("include/acl_operation.php");
require_once ("include/groups.php");
require_once ("include/page_function.php");

initRuleset();
$used_desc = getSession('used_desc', false);

$acls=&$expolicy->acls;
$protocols=$expolicy->protocols;
$periodicities=$expolicy->periodicities;
$durations=$expolicy->durations;
$groups=&$expolicy->groups;
$applications=$expolicy->applications;
$oss=$expolicy->oss;
$resources=$expolicy->resources;
$auths=$expolicy->auths;
$descs=$expolicy->descs;

$delete=getHttp('delete');
$clone=getHttp('copy');
$ch_name=getHttp('ch_name');
$acl_nb=getHttp('acl_nb');
$ch_group=getHttp('group');
$ch_acl=getHttp('acl');
$macl=getHttp('macl');
$up=getHttp('up');
$down=getHttp('down');
$ch_comment=getHttp('comment');
$gr_enabled=getHttp('gr_enabled');
$modify_groups=getHttp('modify_groups');
$del_grp_id = getHttp('del_grp');
$disp_bichain = getHttp('bichain');
$gr_high = getHttp('grhigh', 0);

$chain_from = getHttp('chainfrom');
$chain_to = getHttp('chainto');

#INPUT STRICT CHECKING
if (!check_nb($ch_group))
{
    log_and_exit(-1);
}

if (!check_nb($ch_acl))
{
    log_and_exit(-1);
}

if (!check_nb($gr_high))
{
    log_and_exit(-1);
}

$bichains = getSession('bichains');

#get order for every bichain

$valid = False;
#make bichain with from/to if available
if($chain_from && $chain_to){
    $disp_bichain = "$chain_from-$chain_to";
} else if ($disp_bichain) {
    $parts = explode('-', $disp_bichain, 2);
    if (count($parts) == 2) {
        $chain_from = $parts[0];
        $chain_to = $parts[1];
    }
}
$bichain_label = $disp_bichain;
if (!isset($disp_bichain) or $disp_bichain == '' or ($disp_bichain=='View All'))
{
  $valid = True;
  $disp_bichain = 0;
}else{
  foreach($bichains as $key=>$data)
  {
    if (strcmp(($data['label']),$disp_bichain)!=0)
    {
      continue;
    }
    $valid = True;
    $disp_bichain = $key;
    break;
  }
}
if ( ! $valid)
{
  add_log(sprintf(_('Illegal argument received for bichain: "%s"'), $disp_bichain));
  $disp_bichain = null;
  $bichain_label = null;
  $chain_from = null;
  $chain_to = null;
}

if ((!isset($ch_acl) or ($ch_acl == "")) and (!isset($delete)))
{
  foreach($acls->ordered_list_tab() as $key => $foo){
    $myacl = $acls->get_elt($key);
    if (!isset($myacl->from) or ($myacl->from==""))
    {
      log_error(_("This object is shown by default because NuFace believes it is not complete"));
      $ch_acl=$myacl->ID;
      break;
    }
    if (!isset($myacl->to) or ($myacl->to==""))
    {
      log_error(_("This object is shown by default because NuFace believes it is not complete"));
      $ch_acl=$myacl->ID;
      break;
    }
    if (!isset($myacl->decision) or ($myacl->decision==""))
    {
      $ch_acl=$myacl->ID;
      log_error(_("This object is shown by default because NuFace believes it is not complete"));
      break;
    }
  }
}

# store in session the acl to display in detail
# or get ch_acl from session
if (isset($ch_acl) && $ch_acl == "") {
   $ch_acl = null;
} else if (isset($ch_acl)) {
    $_SESSION['acl'] = $ch_acl;
} else if (isset($bichain_label)) {
    $ch_acl = getSession('acl', false);
    if ($ch_acl and !$expolicy->acls->has_elt($ch_acl)) {
        $ch_acl = null;
        unset($_SESSION['acl']);
    }
}

print_acls_onload($nufw_firewall);

if (isset($ch_acl) and ($ch_acl==0))
{
  log_error(_("The connection you selected was dropped because there is no specific ACL matching that connection. If you want to accept such connections, you probably need to create a new ACL or modify an existing one"));
}

if ((isset($down)) and ($down==1))
  $up=-1;

if (getHttp('new_acl') == 1) {
    $new_acl = createAcl($expolicy);
    if ($new_acl)
        $ch_acl = $new_acl->ID;

} else if ($modify_groups==1) {
    modify_groups($expolicy);

} else if (getHttp('new_group') == 1) {
    createAclGroup($expolicy);

} elseif (isset($ch_acl) and isset($ch_name)) {
    $ok = changeAcl($expolicy, $ch_acl);
    if ($ok)
        $ch_acl = null;
} elseif (isset($delete)) {
    deleteAcl($expolicy, $delete);
    deletefromhistory('acls',$delete);
    unset($_SESSION['acl']);

} elseif (isset($clone)) {
    cloneAcl($expolicy, $clone);

} elseif ((isset($macl)) and (isset($up)) and (($up==1) or ($up==-1))) {
  $list=$acls->ordered_list_tab();
  if (!isset($list))
  {
    $list=array();
  }
  $current=0;$in=0;
  foreach ($list as $is=>$value)
  {
    $last=$current;
    $current=$is;
    if ($current == $macl)
      $in=1;
    if ($in==1)
    {
      if (($last==0) and ($up==1)) #Cannot bring top element up
        break;
      #bring an element down means bring the following element up
      if ($up==-1)
      {
        $up=1;
        continue;
      }
      $cur_elt=&$acls->get_elt($current);
      $last_elt=&$acls->get_elt($last);
      $tmpid=$cur_elt->ID;
      $cur_elt->ID=$last_elt->ID;
      $last_elt->ID=$tmpid;
      $acl1=$acls->get_elt($cur_elt->ID);
      $acl2=$acls->get_elt($last_elt->ID);
      $acls->del_elt($cur_elt->ID);
      $acls->del_elt($last_elt->ID);
      $acls->add_elt($acl1,'data',$last_elt->ID);
      $acls->add_elt($acl2,'data',$cur_elt->ID);

      saveRuleset($expolicy);
      break;
    }
  }
}

if ($_SESSION['need_acl_recalc'] != 0)
{
  recompute_all_descsorts($expolicy, $descs->elts[$used_desc]);
  sessionSaveRuleset($expolicy);
}

$bichain_name = $bichain_label;
$aclorder = getHttp('dndSort_BICHAIN');
if ($bichain_name and $aclorder)
{
    saveAclOrder($expolicy, $acls, $aclorder, $used_desc, $bichains, $bichain_name);
    $acls =& $expolicy->acls;
}

$acl=getHttp('acl');
if (!check_nb($acl))
{
    log_and_exit(-1);
}
$acl_menu_class = "aclmenu_ext";
echo "<div class=\"$acl_menu_class\" id=\"c1\">\n";
if (array_key_exists($disp_bichain, $bichains))
    $mybichain=$bichains[$disp_bichain];
else
    $mybichain=null;
$display = new DisplayAcl($expolicy);
$display->current_acl = $ch_acl;
$display->gr_high = $gr_high;
$display->chain_from = $chain_from;
$display->chain_to = $chain_to;
if (isset($bichain_label)){
    $display->html_acls_bichain($bichains[$disp_bichain]);
}else{
    $display->html_all_acls($chain_from, $chain_to, $ch_group,'acls');
}
unset($display);
print "\n</div>\n";

display_acl_form();

#
# Display Acl detail
#
begin_content_detail();
if ($ch_acl) {
    require_once ("include/edit_acl.php");
    editAcl($expolicy, $bichains, $ch_acl, $bichain_label, $chain_from, $chain_to, $gr_high, $aclorder);
}else{
    display_groups($expolicy);
}
end_content_detail();
updateHistoryWrapper($title, $ch_acl, $expolicy->acls);

require_once ("include/footer.php");
?>
