#!/bin/bash
#
# Copyright (C) 2007 INL
# Written by Damien Boucard <damien.boucard AT inl.fr>
#

# Setting variables
LOCAL_RULES_DIR="$1"
SSH_USER="$2"
SSH_HOST="$3"
REMOTE_RULES_DIR="$4"
REMOTE_SUDO_COMMAND="$5"
REMOTE_FIREWALL_SCRIPT="$6"
REMOTE_FIREWALL_SCRIPT_ARG="$7"

# Getting ACL filename
set `head -1 $LOCAL_RULES_DIR/nufw/forward_rules`
while [[ "$2" != "" ]]; do shift; done
ACL_FILENAME="$1"

# Sending local rules to the remote machine
scp -r $LOCAL_RULES_DIR/* $SSH_USER@$SSH_HOST:$REMOTE_RULES_DIR/ || exit 99

# Sending local ACL file to the remode machine (with renaming)
scp $ACL_FILENAME $SSH_USER@$SSH_HOST:$ACL_FILENAME.backup.xml || exit 99

# Reloading remote firewall rules
ssh $SSH_USER@$SSH_HOST "$REMOTE_SUDO_COMMAND $REMOTE_FIREWALL_SCRIPT $REMOTE_FIREWALL_SCRIPT_ARG" || exit 98
