<?php
require_once('test_common.php');
require_once(NUFACE_DIR . 'include/ruleset.class.php');

define('DESC_FILENAME', NUFACE_DIR . 'doc/empty.xml');

class TestPolicy extends UnitTestCase {
    function testFileDoesntExist() {
        $filename = '/filedoesntexist.xml';
        $this->expectException(new Exception('No such file: "'.$filename.'".'));
        $ruleset = new policy($filename);
    }

    function testXMLSyntaxError() {
        $filename = NUFACE_DIR . 'README';
        $this->expectException(new Exception('XML syntax error.'));
        $ruleset = new policy($filename);
    }

    function testVersion12() {
        $this->expectException(new Exception('This ruleset targets NuFace 1.2, pleasy upgrade the ruleset manually.'));
        $ruleset = new policy(NUFACE_DIR . 'tests/acl_version12.xml');
    }
}

?>
