<?php
# Copyright(C) 2004-2007 INL
# Written by Jean Gillaux <jean@inl.fr>
#
# $Id: aclajax.php 17927 2009-02-16 13:16:09Z haypo $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

$title = 'acls';
require_once ("include/common.php");
require_once ("include/display.php");
require_once ("include/ruleset.class.php");

function edw_404_msg($msg){
    header("HTTP/1.0 404 Not Found");
    header("EDW-Message: $msg");
}

$expolicy = initRuleset();
$used_desc = getSession('used_desc', false);
$bichains = getSession('bichains');
$acls = $expolicy->acls;

#Group to highlight, if any
$gr_high = getHttp('grhigh');
# bichain
$disp_bichain = getHttp('bichain');
# args for X-ALL or ALL-X bichains
$chain_from = getHttp('chainfrom');
$chain_to = getHttp('chainto');

#
# validate  bichain
$valid_bichain = 0;
if (!isset($disp_bichain) or ($disp_bichain=='View All'))
{
  $valid_bichain = 1;
  $disp_bichain = 0;
}else{
  foreach($bichains as $key=>$data)
  {
    if (strcmp(($data['label']),$disp_bichain)!=0)
    {
      continue;
    }
    $valid_bichain = 1;
    $disp_bichain = $key;
    break;
  }
}

# warning message for bad bichain
# only if chainfrom and chainto args are not set
if ($valid_bichain != 1 && !isset($chain_from) && !isset($chain_to)){
    edw_404_msg(_("Illegal argument received for bichain"));
    exit(0);
}


/* display acls */
$display = new DisplayAcl($expolicy);
$display->gr_high = $gr_high;
if (!isset($chain_from) && !isset($chain_to)){
    $display->html_acls_bichain($bichains[$disp_bichain]);
}elseif(isset($chain_from) || isset($chain_to)){
    $display->html_all_acls($chain_from, $chain_to);
}
unset($display);

?>
