<?php
# Copyright(C) 2004-2008 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#	     Jean Gillaux <jean@inl.fr>
#
# $Id: footer.php 17927 2009-02-16 13:16:09Z haypo $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

require_once ("nuphp/debug.php");     /* print_console_content() */
require_once ("include/version.php");   /* $nuface_version */
require_once ("nuphp/i18n.php");      /* get_language() */
require_once ("nuphp/session.php");   /* getSession() */

function get_production_rules_timestamp()
{
    global $std_rules_dir;

    if (!file_exists($std_rules_dir."/forward_rules"))
        return null;

    $rules = @fopen($std_rules_dir."/forward_rules",'r');
    if (!$rules)
        return null;
    $matches="";

    while (!feof($rules)) {
        $line = fgets($rules, 4096);
        if (preg_match("/^#Generated by nupyf on (.*) from (.*)$/",$line,$matches)>0)
        {
            return Array(
                'ruleset'=>filenameWithoutXml($matches[2]),
                'timestamp' => $matches[1],
            );
        }
    }
}

function nuface_footer()
{
    global $nuface_version, $logout_link, $debug_nuface;

    print_console_content();

    echo '<div class="footer">';

    echo '<div class="help">';
    echo '<a href="doc/nuface/'.get_language().'/" target="_new"><img src="images/help.png" alt="'._('Help').'"> '._('Help').'</a>';
    echo '</div>';
    echo '<p><a href="http://software.inl.fr/trac/wiki/EdenWall/NuFace">NuFace</a> version '.$nuface_version.'</p>';

    $prod = get_production_rules_timestamp();
    $ruleset = getSession('document');
    if ($ruleset) {
        $xml_file = $ruleset->filename;
        if ($xml_file) {
            if ($prod) {
	        echo "<p>"._("Production ruleset: ");
	        echo '<em>'.$prod['ruleset'].'</em> ';
	        echo '('.$prod['timestamp'].')</p>';
	    }
            print "<p>".sprintf(_("Working on: %s"), '<em>'.filenameWithoutXml($xml_file).'</em>').'</p>';
	}
    }

    if ($logout_link) {
        echo '<p><a href="logout.php">Logout</a></p>';
    }

    echo '<p>Copyright 2004-2008, <a href="http://www.inl.fr">INL</a></p>'."\n";

    if ($debug_nuface) {
        global $nuface_benchmark_start;
        $diff = getmicrotime() - $nuface_benchmark_start;
        echo sprintf('<p>'._("Page generated in %.1f ms").'</p>'."\n", $diff*1000);
    }

    // Get Firefox javascript
    $html = '<br><a href="http://www.spreadfirefox.com/">';
    $html .= '<img border="0" alt="Get Firefox!" title="Get Firefox!" src="images/get_firefox.gif"></a>';
    html_javascript(Array(
        'if (navigator.appName == "Microsoft Internet Explorer" && (parseInt(navigator.appVersion) >= 4)) {',
        sprintf('   document.write(%s);', quote_javascript($html)),
        '}',
    ));

    echo '<hr class="spacer">';
    echo "</div>\n";
}

nuface_footer();

?>
