<?php
# Copyright(C) 2004-2008 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#
# $Id: types.php 17927 2009-02-16 13:16:09Z haypo $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

$VALID_DECISIONS = Array('accept', 'drop', 'reject');
$VALID_PROTOCOLS = Array('tcp','udp','icmp','esp','ah','gre','vrrp');

$types{'elt'}{'ID'}{'edit'}=0;
$types{'elt'}{'ID'}{'must'}=1;
$types{'elt'}{'ID'}{'type'}='num';

$types{'elt'}{'type'}{'edit'}=0;
$types{'elt'}{'type'}{'must'}=1;
$types{'elt'}{'type'}{'type'}='type';

$types{'elt'}{'sport'}{'edit'}=1;
$types{'elt'}{'sport'}{'must'}=0;
$types{'elt'}{'sport'}{'type'}='portrange';

$types{'elt'}{'dport'}{'edit'}=1;
$types{'elt'}{'dport'}{'must'}=0;
$types{'elt'}{'dport'}{'type'}='portrange';

$types{'elt'}{'icmptype'}{'edit'}=1;
$types{'elt'}{'icmptype'}{'must'}=0;
$types{'elt'}{'icmptype'}{'type'}='alphanum';

$types{'elt'}{'comment'}{'edit'}=1;
$types{'elt'}{'comment'}{'must'}=0;
$types{'elt'}{'comment'}{'type'}='alphanum';

$types{'elt'}{'name'}{'edit'}=1;
$types{'elt'}{'name'}{'must'}=0;
$types{'elt'}{'name'}{'type'}='alphanum2';

$types{'elt'}{'linkid'}{'edit'}=1;
$types{'elt'}{'linkid'}{'must'}=0;
$types{'elt'}{'linkid'}{'type'}='alphanum';

$types{'elt'}{'net'}{'edit'}=1;
$types{'elt'}{'net'}{'must'}=0;
$types{'elt'}{'net'}{'type'}='network';

$types{'elt'}{'proto'}{'edit'}=1;
$types{'elt'}{'proto'}{'must'}=0;
$types{'elt'}{'proto'}{'type'}='proto';

$types{'elt'}{'l7rule'}{'edit'}=1;
$types{'elt'}{'l7rule'}{'must'}=0;
$types{'elt'}{'l7rule'}{'type'}='alphanum';

$types{'elt'}{'l7proto'}{'edit'}=1;
$types{'elt'}{'l7proto'}{'must'}=1;
$types{'elt'}{'l7proto'}{'type'}='alphanum';

$types{'elt'}{'action'}{'edit'}=1;
$types{'elt'}{'action'}{'must'}=0;
$types{'elt'}{'action'}{'type'}='alphanum';

$types{'elt'}{'prefix'}{'edit'}=1;
$types{'elt'}{'prefix'}{'must'}=0;
$types{'elt'}{'prefix'}{'type'}='alphanum';

$types{'elt'}{'start'}{'edit'}=1;
$types{'elt'}{'start'}{'must'}=0;
$types{'elt'}{'start'}{'type'}='num';

$types{'elt'}{'stop'}{'edit'}=1;
$types{'elt'}{'stop'}{'must'}=0;
$types{'elt'}{'stop'}{'type'}='num';

$types{'elt'}{'duration'}{'edit'}=1;
$types{'elt'}{'duration'}{'must'}=0;
$types{'elt'}{'duration'}{'type'}='num';


$types{'elt'}{'vpn'}{'edit'}=1;
$types{'elt'}{'vpn'}{'must'}=0;
$types{'elt'}{'vpn'}{'type'}='vpn';

$types{'elt'}{'group'}{'edit'}=1;
$types{'elt'}{'group'}{'must'}=0;
$types{'elt'}{'group'}{'type'}='num';

$types{'elt'}{'ApplicationPath'}{'edit'}=1;
$types{'elt'}{'ApplicationPath'}{'must'}=0;
$types{'elt'}{'ApplicationPath'}{'type'}='fspath';

$types{'elt'}{'OSName'}{'edit'}=1;
$types{'elt'}{'OSName'}{'must'}=0;
$types{'elt'}{'OSName'}{'type'}='glob';

$types{'elt'}{'OSRelease'}{'edit'}=1;
$types{'elt'}{'OSRelease'}{'must'}=0;
$types{'elt'}{'OSRelease'}{'type'}='glob';

$types{'elt'}{'OSVersion'}{'edit'}=1;
$types{'elt'}{'OSVersion'}{'must'}=0;
$types{'elt'}{'OSVersion'}{'type'}='glob';

$types{'elt'}{'startday'}{'edit'}=1;
$types{'elt'}{'startday'}{'must'}=0;
$types{'elt'}{'startday'}{'type'}='num';

$types{'elt'}{'stopday'}{'edit'}=1;
$types{'elt'}{'stopday'}{'must'}=0;
$types{'elt'}{'stopday'}{'type'}='num';

$types{'elt'}{'starthour'}{'edit'}=1;
$types{'elt'}{'starthour'}{'must'}=0;
$types{'elt'}{'starthour'}{'type'}='num';

$types{'elt'}{'stophour'}{'edit'}=1;
$types{'elt'}{'stophour'}{'must'}=0;
$types{'elt'}{'stophour'}{'type'}='num';


$types{'ress'}{'ID'}{'edit'}=0;
$types{'ress'}{'ID'}{'must'}=1;
$types{'ress'}{'ID'}{'type'}='num';

$types{'ress'}{'name'}{'edit'}=1;
$types{'ress'}{'name'}{'must'}=0;
$types{'ress'}{'name'}{'type'}='alphanum';

$types{'ress'}{'comment'}{'edit'}=1;
$types{'ress'}{'comment'}{'must'}=0;
$types{'ress'}{'comment'}{'type'}='alphanum';

$types{'ress'}{'defaultaction'}{'edit'}=1;
$types{'ress'}{'defaultaction'}{'must'}=0;
$types{'ress'}{'defaultaction'}{'type'}='alphanum';

$types{'ress'}{'defaultprefix'}{'edit'}=1;
$types{'ress'}{'defaultprefix'}{'must'}=0;
$types{'ress'}{'defaultprefix'}{'type'}='alphanum';


function get_l7_protos($l7_protos_file){
  if (!is_readable($l7_protos_file))
  {
    add_log(sprintf(_('Cannot open file "%s".'), $l7_protos_file));
    return(NULL);
  }
  $res=array();
  $handle = @fopen($l7_protos_file, "r");
  if ($handle) {
    while (!feof($handle)) {
      $buffer = fgets($handle, 4096);
      if (!preg_match('/^\s*#/',$buffer))
      {
        $buffer = trim($buffer);
        if ($buffer != '')
        {
          array_push($res,$buffer);
        }
      }
    }
  fclose($handle);
  }
  return($res);
}

function _check_input_var($elt_type, $type, $value)
{
  global $types;
  if (!array_key_exists($elt_type, $types)
      || !array_key_exists($type, $types[$elt_type]))
  {
    return '';
  }

  $check_type = $types{$elt_type}{$type}{'type'};
  if ($check_type == 'alphanum') {
    if (!preg_match('@^[a-zA-Z0-9 _.,:!()/-]*$@',$value))
      return _('Only letters, numbers, spaces and the characters ".,:!()/-" are allowed');

  } else if ($check_type == 'glob') {
    if (!preg_match('@^[a-zA-Z0-9 _.,:!()/*?-]*$@',$value))
      return _('Only letters, numbers, spaces and the characters "?*.,:!()/-" are allowed');

  } else if ($check_type == 'alphanum2') {
    /* alphanum2 = alphanum + antislash */
    if (!preg_match('@^[a-zA-Z0-9 _.,:!()\\\\/-]*$@',$value))
      return _('Only letters, numbers, spaces and the characters ".,:!()\\/-" are allowed');

  } else if ($check_type == 'fspath') {
    if (!preg_match("/^[a-zA-Z0-9*?:_\-\.\s\/\\\\]*$/",$value))
      return _('Only letters, numbers, spaces and characters "*?:_-./\\" are allowed');

  } else if ($check_type == 'network'){
    if (!preg_match("/^[0-9_.\/]*$/",$value))
      return _('Only host or network addresses are allowed');
    if (!preg_match("/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}(?:|\/\d{1,2}(?:|\d{0,1}\.\d{1,3}\.\d{1,3}\.\d{1,3}))$/",$value))
      return _('Only host or network addresses are allowed');

  } else if ($check_type == 'num') {
    if (!preg_match("/^[0-9]*$/",$value))
      return _('Only positive numbers are allowed');

  } else if ($check_type == 'type') {
    if (!check_element_type($value))
      return _('Only a valid type can be accepted');

  } else if ($check_type == 'proto') {
      if (!check_protocol($value))
          return _('Only a valid protocol can be accepted');

  } else if ($check_type == 'periodicity') {
    if (($value!='startday') and ($value!='starthour') and ($value!='stopday') and ($value!='stophour'))
      return _('Only a valid period type can be accepted');

  } else if ($check_type == 'portrange') {
    // port range is checked by elt::check_consistency()

  } else {
    return sprintf('Invalid check type: "%s"', $check_type);
  }
  return null;
}

function check_input_var($elt_type, $type, $var, $input_name=null)
{
    $err_msg = _check_input_var($elt_type, $type, $var);
    if (!$err_msg)
        return true;
    if (!$input_name)
        $input_name = $type;
    log_error(sprintf(_('Invalid value received for the parameter "%s": %s!'),
        $input_name, $err_msg));
    return false;
}

function possible_values($elt_type,$type){
  global $valid_icmp_types, $nufw_firewall, $l7_firewall, $l7_protos_file;
  global $VALID_DECISIONS, $VALID_PROTOCOLS;
  global $ress;

  if ($elt_type=='elt')
  {
    if ($type == 'type')
      {
        $ret=array('ipv4','local_ipv4','link','proto','app');
        if ($nufw_firewall)
        {
          $ret=array('ipv4','local_ipv4','nufw','link','proto','app');
        }
        if ($l7_firewall)
        {
          array_push($ret,'l7rule');
        }
        return($ret);
      }
    if ($type == 'defaultaction')
      return(array('drop','accept','ulogaccept','ulogdrop','logaccept','logdrop'));
    if ($type == 'action')
      return(array('accept','ulogaccept','ulogdrop','logaccept','logdrop'));
    if ($type == 'l7proto')
      return(get_l7_protos($l7_protos_file));
    if ($type == 'proto')
      return($VALID_PROTOCOLS);
    if ($type == 'periodicity')
      return(array('startday','stopday','starthour','stophour'));
    if ($type == 'open_proto')
      return(array_merge(array('--'), $VALID_PROTOCOLS));
    if ($type == 'linkid')
      return($ress);
    if (($type == 'startday') or ($type == 'stopday'))
      return(range(1,7));
    if (($type == 'starthour') or ($type == 'stophour'))
      return(range(0,24));
  }elseif ($elt_type=='ress')
  {
    if ($type == 'defaultaction')
      return(array('drop','accept','ulogaccept','ulogdrop','logaccept','logdrop'));
  } elseif ($elt_type=='acl') {
    if ($type == 'decision')
      return $VALID_DECISIONS;
  } elseif ($elt_type == 'proto') {
    if ($type == 'icmptype')
      return $valid_icmp_types;
  }
  return(0);
}

function possible_fields($elt_type,$type=0){
  global $l7_firewall;
  if ($elt_type=='elt'){
    if ($type == 'nufw')
      return(array('ID','name','group','modified','comment'));
    if ($type == 'local')
      return(array('ID','name','modified','comment'));
    if (($type == 'ipv4') or ($type == 'local_ipv4'))
      return(array('ID','name','net','modified','comment'));
    if ($type == 'proto'){
      $ret = array('ID','name','proto','dport','sport','icmptype','modified','comment');
      if ($l7_firewall){
        $ret = array('ID','name','proto','dport','sport','icmptype','l7rule','modified','comment');
      }
      return($ret);
    }
    if ($type == 'l7rule')
      return(array('ID','name','l7proto','action','prefix','modified','comment'));
    if ($type == 'periodicity')
      return(array('ID','name','startday','stopday','starthour','stophour','modified','comment'));
    if ($type == 'duration')
      return(array('ID','name','duration','modified','comment'));
    if ($type == 'link')
      return(array('ID','name','linkid'));
    if ($type == 'app')
      return(array('ID','name','ApplicationPath','modified','comment'));
    if ($type == 'os')
      return(array('ID','name','OSName','OSRelease','OSVersion','modified','comment'));
  }elseif (($elt_type=='apps') or ($elt_type=='auth') or ($elt_type=='ress')
           or ($elt_type=='periodicity') or ($elt_type=='duration')
           or ($elt_type=='os')) {
      return(array('ID','name','modified','comment'));
  }elseif ($elt_type=='l7rule'){
      return(array('ID','name','defaultaction','defaultprefix','modified','comment'));
  }
  return Array();
}

?>
